package ddejonge.nb3;




/**
 * Abstract class that represents an action that can be executed on a world state by one or more agents.
 * 
 * @author ddejonge
 *
 */
public abstract class NB3Action {
	
	/**
	 * The agents that are to execute this action. This set determines to which agents a plan containing this action is going to be proposed.
	 */
	protected NB3AgentSet participatingAgents;
	
	NB3AgentSet getParticipatingAgents(NB3SessionInfo sessionInfo){
		
		if(participatingAgents == null){
			participatingAgents = determineParticipatingAgents();
		}
		
		return participatingAgents;
	}
	
	/** 
	 * Sets the participating agents. This is domain dependent, so therefore this method is abstract.
	 */
	protected abstract NB3AgentSet determineParticipatingAgents();
}
