package ddejonge.nb3;

/**
 * Tool for debugging.
 * 
 * Implementation of the DataMonitor class specific to NB3.
 * 
 * @author Dave de Jonge
 *
 */
public class NB3DataMonitor extends DataMonitor {

	NB3Algorithm nb3Algorithm;
	
	public NB3DataMonitor(NB3Algorithm nb3Algorithm) {
		super();
		
		this.nb3Algorithm = nb3Algorithm;
		
		this.setProperty(1, "Time till deadline:");
		this.setProperty(2, "Nodes explored:");
		this.setProperty(3, "Rational proposals found:");
		this.setProperty(4, "Proposals made:");
		this.setProperty(5, "Proposals received:");
		this.setProperty(6, "Proposals accepted:");
		this.setProperty(7, "Deals made:");
		
		
		this.setSize(300, 200);
	}
	
	void setValues(){
		
		if(!this.isEnabled()){
			return;
		}
		
		this.setValue("Time till deadline:", nb3Algorithm.getTimeTillDeadline() / 1000);
		this.setValue("Nodes explored:", nb3Algorithm.getNumberOfNodesGenerated());
		this.setValue("Rational proposals found:", nb3Algorithm.getNumFoundByUs());
		this.setValue("Proposals made:", nb3Algorithm.getNumProposedByUs());
		this.setValue("Proposals received:", nb3Algorithm.getNumProposedToUs());
		this.setValue("Proposals accepted:", nb3Algorithm.getNumAcceptedByUs());
		this.setValue("Deals made:", nb3Algorithm.getNumDealsMade());
		
		this.update();
	}

}
