package ddejonge.nb3;





import java.util.ArrayList;

import ddejonge.nb3.Logger;




class NB3Logger extends Logger{
	
	NB3SessionInfo sessionInfo;
	
	//INHERITED FIELDS
 	//String runFolderPath;
 	//String fileName;
 	//String filePath;
 	//public boolean enabled = false;
	
	
	NB3Logger(){		 		

	}
	
	NB3Logger(int _capacity){
		super(_capacity);
	}
	
	
	/*
	public void enable(NB3SessionInfo sessionInfo, String folderPath, String fileName){	
		enable(sessionInfo, folderPath, fileName, false);		 
	}*/
	 
	void enable(NB3SessionInfo sessionInfo, String folderPath, String fileName, boolean useTimeStamp){
		
		if(useTimeStamp){			
			fileName = getDateString() + "_" + fileName;
		}
		
		 if(enabled == false){
			 content = new ArrayList<String>(capacity);
			 content.add(""); //ugly way to solve a bug. log() replaces the last element, so there must already be at least one element.
		 }		 
		 enabled =  true;		 
		 
		 //set the correct file name and path.
		 this.folderPath = folderPath;
		 this.fileName = fileName;
	
		 this.sessionInfo = sessionInfo;
	}


	/**
	 * This method is called whenever a new node is added to the tree.
	 * @param node the new node added to the tree.
	 */
	void logNode(NB3Node node){
		
		if(!enabled){return;}
		
		logSeparationLineHead();
		logln("ID: " + node.nodeId);
		logln("depth: "+ node.depth);
		if(node.parent != null){
			logln("parent: " + node.parent.nodeId);
		}
		logln("node type: " + node.getType());
		if(node.label != null){
			logln("label: " + node.label.toString());
		}
		/*logln("********");*/
		/*logSeparationLineFoot();*/
	}
	
	
	
	void logOrigBounds(NB3Tree theTree){
		
		if(!enabled){return;}
		
		String[] agentNames = sessionInfo.agentNames;
		int numAgents = agentNames.length;
		
		logln("");
		logln("\t");
		for(int i=0; i<numAgents; i++){				
			log(agentNames[i] + "     ");
		}
		
		if(theTree.original_gub != null){
			logln("or. gub");
			for(int i=0; i<numAgents; i++){				
				log("\t" + theTree.original_gub[i]);
			}
		}
		if(theTree.original_rv != null){
			logln("or. rv");
			for(int i=0; i<numAgents; i++){				
				log("\t" + theTree.original_rv[i]);
			}
		}
	}
	
	
	/**
	 * Logs all the bounds.
	 * 
	 * @param node
	 */
	void logBounds(NB3Node node, NB3AgentSet pa) {
		
		if(!enabled){return;}
		
		String[] agentNames = sessionInfo.agentNames;
		int numAgents = agentNames.length;
		
		
		int columnWidth = 10;
		
		logln("");
		
		//log the Power names
		String s = "";
		while(s.length() < columnWidth){
			s+= " ";
		}
		logln(s);
	
		
		for(int i=0; i<numAgents; i++){	
			
			s = agentNames[i];
			while(s.length() < columnWidth){
				s = " " + s;
			}
			log(s);
		}
		
		/*	
		s = "gub";
		while(s.length() < columnWidth){
			s+= " ";
		}
		logln(s);
		for(int i=0; i<numAgents; i++){
			float r = ((float)Math.round(node.theTree.getGUB(i) * 10))/10f;
			s = "" + r;
			while(s.length() < columnWidth){
				s= " " + s;
			}
			log(s);
		}*/
		
		if(node.ub != null){
			s = "ub";
			while(s.length() < columnWidth){
				s+= " ";
			}
			logln(s);
			for(int i=0; i<numAgents; i++){		
				float r = ((float)Math.round(node.ub[i] * 10))/10f;
				s = "" + r;
				while(s.length() < columnWidth){
					s = " " + s;
				}
				log(s);
			}
		}	
		
		
		/*
		s = "rv";
		while(s.length() < columnWidth){
			s+= " ";
		}
		logln(s);
		for(int i=0; i<numAgents; i++){		
			float r = ((float)Math.round(node.theTree.getRV(i) * 10))/10f;
			s = "" + r;
			while(s.length() < columnWidth){
				s = " "+s;
			}
			log(s);
		}*/
		
		if(node.e != null){
			
			s = "e";
			while(s.length() < columnWidth){
				s+= " ";
			}
			logln(s);
			for(int i=0; i<numAgents; i++){		
				float r = ((float)Math.round(node.e[i] * 10))/10f;
				s = "" + r;
				while(s.length() < columnWidth){
					s = " " + s;
				}
				log(s);
			}
		}
		if(node.lb != null){
			s = "lb";
			while(s.length() < columnWidth){
				s+= " ";
			}
			logln(s);
			for(int i=0; i<numAgents; i++){		
				float r = ((float)Math.round(node.lb[i] * 10))/10f;
				s = "" + r;
				while(s.length() < columnWidth){
					s = " " + s;
				}
				log(s);
			}
		}

/*
		s = "glb";
		while(s.length() < columnWidth){
			s+= " ";
		}
		logln(s);
		for(int i=0; i<numAgents; i++){		
			float r = ((float)Math.round(node.theTree.getGLB(i) * 10))/10f;
			s = "" + r;
			while(s.length() < columnWidth){
				s = " "+s;
			}
			log(s);
		}
	*/
		
		if(node.e != null){
			logln("");
			s = "nut";
			while(s.length() < columnWidth){
				s+= " ";
			}
			logln(s);
			for(int i=0; i<numAgents; i++){		
				
				if(pa.contains(i)){
					s = "" + (int) ( 100 * node.getNormalizedUtility(i) ) ;
					while(s.length() < columnWidth){
						s = " " + s;
					}
				}else{
					s = "---";
					while(s.length() < columnWidth){
						s = " " + s;
					}
				}
				

				log(s);
			}
		}
		if(node.prob != null){
			s = "prb";
			while(s.length() < columnWidth){
				s+= " ";
			}
			logln(s);
			
			
			for(int i=0; i<numAgents; i++){		
				
				if(node.prob[i]<0){
					s = "-";
				}else{				
					s = "" + (int) (100 * node.prob[i]);
				}
				while(s.length() < columnWidth){
					s = " " + s;
				}
				log(s);
			}
		}
		/*
		logln("participating agents: ");
		
		for(String ag : n..getPA()){
			log(ag + " ");
		}		
		*/
		logln("Expansion heuristic: " + node.getExpansionHeuristic());
		
		logSeparationLineFoot();
		
   }
	
	
	void logBestProposals(NB3Proposal bestFoundByUs, NB3Proposal bestProposedToUs, double my_asp, double opp_asp){
		
		if(!enabled){return;}
		
		logln("");
		logln("");
		logln("---------------------------------------");		
		logln("\tmin\t\tf.ByMe\t\tp.2Us");		
		
		
		String newLine = "myAsp\t" + NB3Utilities.double2Percentage(my_asp);
		newLine += "\t\t";
		newLine += sat2percentage(bestFoundByUs, true);
		newLine += "\t\t";
		newLine += sat2percentage(bestProposedToUs, true);
		logln(newLine);
		
		
		newLine = "oppAsp\t" + NB3Utilities.double2Percentage(opp_asp);
		newLine += "\t\t";
		newLine += sat2percentage(bestFoundByUs, false);
		newLine += "\t\t";
		newLine += sat2percentage(bestProposedToUs, false);		
		logln(newLine);
	}
	
	
	private String sat2percentage(NB3Proposal prop, boolean displayMySatisfaction){
		
		if(prop == null){
			return "-";
		}
		
		int percentage;
		
		if(displayMySatisfaction){
			percentage = NB3Utilities.double2Percentage(prop.myNormalizedUtility);
		}else{
			percentage = NB3Utilities.double2Percentage(prop.oppNormalizedUtility);
		}
		
		return Integer.toString(percentage);		
	}
	
	
	void logProposalMade(NB3Proposal proposal, int myAgentID, float my_original_gub, double my_asp, double opp_asp){
		
		if(!enabled){return;}
		
		logln();
		logln("*****Nb3Logger.logProposalMade() WE ARE PROPOSING:");
		logln(proposal.toString());
		logln("proposal id: " + proposal.getID());
		logln("node id: " + proposal.correspondingNodeId);
		
		//logln("my normalized utility: " + proposal.normalizedUtility[myAgentID]);
		for(int ag : proposal.getParticipatingAgents()){
			logln(sessionInfo.agentNames[ag] + " normalized utility: " + proposal.normalizedUtility[ag]);
		}
		logln("my asp level: " + my_asp);
		logln("opp asp level: " + opp_asp);
		logln("my orig gub: " + my_original_gub);
		logln("my e: " + proposal.e[myAgentID]);
	
		logln("*****");
		logln();
			
		logln("---------------------------------------");
	}
	
	
	void logIllegalProposalReceived(String myAgentName, NB3Message msg){
		
		if(!enabled){return;}  //if not enabled then sessionInfo is null, so we must check this.
		
		logln(sessionInfo.getCurrentTime() + " " + myAgentName + ": illegal proposal received " + msg.getProposalID());
	}
	
	void logProposalReceived(String myAgentName, NB3Message msg){
		
		if(!enabled){return;} //if not enabled then sessionInfo is null, so we must check this.
		
		
		logln();
		logln(sessionInfo.getCurrentTime() + " " + myAgentName + ": Proposal received " + msg.getProposalID());
	}
	
	void logIncomingProposalNode(NB3Node ipn, NB3AgentSet participatingAgents){
		this.logBounds(ipn, participatingAgents);
		
		/*
		logln("");
		logln("\t");
		for(int i=0; i<numAgents; i++){				
			log(agentNames[i] + "   ");
		}
		logln("gub");
		for(int i=0; i<numAgents; i++){				
			log("\t" + ipn.theTree.gub[i]);
		}
		logln("e  ");
		for(int i=0; i<numAgents; i++){				
			log("\t" + ipn.e[i]);
		}
		logln("lb ");
		for(int i=0; i<numAgents; i++){				
			log("\t" + ipn.lb[i]);
		}
		logln("glb");
		for(int i=0; i<numAgents; i++){				
			log("\t" + ipn.theTree.glb[i]);
		}
		logln("");
		logln("sat");
		for(int i=0; i<numAgents; i++){				
			log("\t" + (int) (100 * ipn.getNormalizedUtility(i))  );
		}
		logln("prb");
		for(int i=0; i<numAgents; i++){				
			log("\t" + (int) (100 * ipn.prob[i])  );
		}
		
		logln("Expansion heuristic: " + ipn.getExpansionHeuristic());*/
	}
	
	
	
	void logNoNodeToSplit(){
		//logln("Nb3Algorithm.splitNode(): No node with positive exp heur");
	}
	
	void logNoLabelToSplit(NB3Node node){
		//logln("Nb3Algorithm.splitNode(): we have no labels to split. method returns. node id: " + node.nodeId + " type: " + node.getType());
	}

	void logEmptyQueue(String codeLocation, int typeOfNodeToSplit, NB3NodeQueue que) {
		logln(codeLocation + ": theTree.queue is empty. type of node to split: " + typeOfNodeToSplit + " sizes of queues: " + que.sizes());
	}
	
	void logChosenNode(String codeLocation, NB3Node maxNode){
		logln(codeLocation + ": node chosen to expand: " + maxNode.nodeId + " with exp heur " + maxNode.getExpansionHeuristic());
	}
	
	void logIncomingAcceptance(NB3Proposal acceptedProp, int accepter){
		
		if(!enabled){return;} //if not enabled then sessionInfo is null, so we must check this.
		
		
		logln("");
		logln("");
		logln("---------------------------------------");
		logln(sessionInfo.getCurrentTime() + " " + acceptedProp.getID() + " ACCEPTED by " + accepter);
		
		logln("---------------------------------------");
		logln("");
		logln("");
	}
	
	
	void logSeparationLineHead(){
		logln("");
		logln("");
		logln("---------------------------------------");
	}
	
	void logSeparationLineFoot(){
		logln("---------------------------------------");
		logln("");
		logln("");
	}

	void logAcceptedProposal(NB3Proposal bestProposedToUs) {
		// TODO Auto-generated method stub
		
	}
	
	void logDealConfirmation(NB3Proposal confirmedDeal){
		logln("DEAL CONFIRMED: " + confirmedDeal.getID());
	}


	
	
}
